% function
% [y]=Raylegh_Sommerfeld_Kernel_lambda_doublesmooth(z,lambda,delta_x,yNN,xNN,smooth_index)

function [y]=Raylegh_Sommerfeld_Kernel_lambda_doublesmooth(z,lambda,delta_x,yNN,xNN,smooth_index)

ffx=0; ffy=ffx;
yy=zeros(yNN,xNN);
[X,Y]=meshgrid(-xNN/2:xNN/2-1,-yNN/2:yNN/2-1); % Kernel Grid
r=sqrt(X.^2*delta_x^2+Y.^2*delta_x^2+z^2*ones(size(X)));
rr=(X.^2*delta_x^2+Y.^2*delta_x^2)/z/2;
%r=abs(z);

if smooth_index==0
    
    %%% ACCURATE y
% y=-i*exp(i*2*pi*r/lambda)./(r+eps)*z./(r+eps)/lambda*delta_x^2; %%% ACCURATE y

%%%%%%%%%% FRESNEL APPROXIMATION for y %%%%%%%%%%%%%
y=-i*exp(i*2*pi/lambda*z).*exp(i*2*pi*rr/lambda)/(z+eps)*z./(z+eps)/lambda*delta_x^2; %% Fresnel Approximation
yy(2:end,2:end)=y(2:end,2:end);
y=yy;
end


if smooth_index==1% Smoothed Function %%%%%%%%%%%%%
r=abs(z);

 ddelta=0.01;
%xNN=1024;
xxx1=[-1:ddelta:1-eps];
x0=[-xNN/2:xNN/2-1];
for s0=1:length(x0)
   % ff(s0)=mean(exp(j*pi*z*delta_x^2*(x0(s0)+0*x).^2/lambda))*.1;
 %  qq1=(1-abs(xxx1)).*exp(i*pi*delta_x^2*(2*x0(s0).*xxx1+xxx1.^2)./z/lambda); %% NO QUADRATIC MAIN TERM

qqx=(1-abs(xxx1)).*exp(i*pi*delta_x^2*(x0(s0)+1*xxx1).^2/z/lambda);
ffx(s0)=mean(qqx(:))*2; %Factor 2 due to the interval [-1,1];

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%
if yNN~=xNN
  y0=[-yNN/2:yNN/2-1];
    for s0=1:length(y0)
   % ff(s0)=mean(exp(j*pi*z*delta_x^2*(x0(s0)+0*x).^2/lambda))*.1;
 %  qq1=(1-abs(xxx1)).*exp(i*pi*delta_x^2*(2*x0(s0).*xxx1+xxx1.^2)./z/lambda); %% NO QUADRATIC MAIN TERM

qqy=(1-abs(xxx1)).*exp(i*pi*delta_x^2*(y0(s0)+1*xxx1).^2/z/lambda);
ffy(s0)=mean(qqy(:))*2;

end
    
else
    ffy=ffx;
end
%keyboard
%exp_function_smoothed=exp(i*2*pi*r/lambda)=exp(i*pi*z*(X.^2*delta_x^2+Y.^2*delta_x^2)/lambda)=
%exp_function_smoothed=(ffy(Y(:,1)+yNN/2+1))'*ffx(X(1,:)+xNN/2+1);
exp_function_smoothed=ffy(Y+yNN/2+1).*ffx(X+xNN/2+1);
%exp_function_smoothed=ffy(Y+yNN/2+2).*ffx(X+xNN/2+2);
%exp_function_smoothed=ffy(Y).*ffx(X);
r=z;
y=-i*exp(i*2*pi*z/lambda).*exp_function_smoothed./(r+eps)*z./(r+eps)/lambda*delta_x^2;
yy(2:end,2:end)=y(2:end,2:end);  %% '
y=yy;
end

%keyboard
